#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>

#define VERSION   "0.09"
#define DUMP_FILE "/crane/todo"
#define CRANE_EXE "/root/crane/Crane"
#define LOG_FILE  "/var/log/crane/crane.log"
#define DELAY_BW_EXE 1 /* Seconds */


typedef struct cmd
{
    int  id;
    char session[32];
    char user[50];
    char ip[16];
    char command[128];
} Cmd;


Cmd get_cmd(char *str)
{
    Cmd cmd;

    cmd.id = atol(strtok(str, ","));
    strcpy(cmd.user, strtok(NULL, ","));
    strcpy(cmd.ip, strtok(NULL, ","));
    strcpy(cmd.command, strtok(NULL, "\n"));
    
    return cmd;
}


char *do_cmd(Cmd cmd)
{
    char *exe = malloc(sizeof(char) * 256);
    printf("id:      %d\n"
           "User:    %s\n"
           "ip:      %s\n"
           "Command: %s\n",
           cmd.id, cmd.user, cmd.ip, cmd.command);

    sprintf(exe, "%s %s", CRANE_EXE, cmd.command);    
    system(exe);
    strcat(exe, "\n");
    
    return exe;
}


void to_log(
    FILE *fp,
    char *str)
{
   time_t timev = time(NULL);

   fprintf(fp, "[%s] %s", ctime(&timev), str);
   fflush(fp);
}   


int main(
    int    argc,
    char **argv)
{
    int   id;
    char *cmdstr;
    char  dname[32]    = DUMP_FILE;
    char  log_name[32] = LOG_FILE;
    char  buf[128];
    FILE *log, *pipe;
    Cmd   cmd;

    if(!(log = fopen(log_name, "a")))
    {
            printf("Error opening log file: %s\n", log_name);
            exit(1);
    }

    fflush(log);
    
    if(!(pipe = fopen(dname, "w+")))
    {
        printf("Error opening pipe file descriptor: %s\n", dname);
        exit(1);
    }
    
    /* While shutdown is not a command */
    id = 0;
    while(!strstr(cmd.command, "shutdown"))
    {
        if(fgets(buf, 128, pipe))
        {
            cmd = get_cmd(buf);
            cmdstr = do_cmd(cmd);
            to_log(log, cmdstr);
            free(cmdstr);
            sleep(DELAY_BW_EXE);
        }
    }
   
    /* Huh huh Beavis its a pipe log huh huh */ 
    fclose(pipe);
    fclose(log);
    
    return 0;
}
