#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#define VERSION   "0.04"
#define DUMP_FILE "/tmp/crane/dump"
#define CRANE_EXE "/root/crane/crane"
#define LOG_FILE  "/var/log/crane/crane.log"

typedef struct cmd
{
    int  id;
    char session[32];
    char user[50];
    char ip[16];
    char command[30];
} Cmd;


Cmd get_cmd(char *str)
{
    Cmd cmd;

    cmd.id = atol(strtok(str, ","));
    strcpy(cmd.user, (char *)strtok(NULL, ","));
    strcpy(cmd.ip, (char *)strtok(NULL, ","));
    strcpy(cmd.command, (char *)strtok(NULL, "\n"));

    return cmd;
}


char *do_cmd(Cmd cmd)
{
    char *exe = malloc(sizeof(char) * 50);
    printf("id:      %d\n"
           "User:    %s\n"
           "ip:      %s\n"
           "Command: %s\n",
           cmd.id, cmd.user, cmd.ip, cmd.command);

    sprintf(exe, "%s %s", CRANE_EXE, cmd.command);    
    system(exe);
    strcat(exe, "\n");
    
    return exe;
}


void to_log(
    FILE *fp,
    char *str)
{
   fprintf(fp, "%s", str);
   fflush(fp);
}   


int main(
    int    argc,
    char **argv)
{
    int   id, pipe;
    char *cmdstr       = NULL;
    char  dname[32]    = DUMP_FILE;
    char  log_name[32] = LOG_FILE;
    char  buf[128];
    FILE *log;
    Cmd   cmd;

    if(!(log = fopen(log_name, "a")))
    {
            printf("Error opening log file: %s\n", log_name);
            _Exit(1);
    }

    fflush(log);
    
    if(!(pipe = open(dname, O_RDWR | O_CREAT | O_TRUNC, 0666)))
    {
        printf("Error opening pipe file descriptor: %s\n", dname);
        _Exit(1);
    }
    
    /* While shutdown is not a command */
    id = 0;
    while(!strstr(cmd.command, "shutdown"))
    {
        if(read(pipe, buf, 128))
        {
            cmd = get_cmd(buf);
            cmdstr = do_cmd(cmd);
            to_log(log, cmdstr);
            free(cmdstr);
        }
    }
   
    /* Huh huh Beavis its a pipe log huh huh */ 
    close(pipe);
    fclose(log);
    
    return 0;
}
